//*******************************************************
//
//	VS1011 + MMC/SD MP3 Player BK1
//
//	MCU:ATmega168
//		efuse:0xF9
//		hfuse:0xD6	BOD 1.8V EEPROMی
//		lfuse:0xE2	CRU 8MHz
//
//	Compiler:	AVR-GCC		3.4.6
//				AVR-LIBC	1.4.2
//				binutils	2.16.1
//
//	2007.3.27	KAWAKAMI Yukio
//*******************************************************

#include	<avr/io.h>
#include	<avr/interrupt.h>
#include	<avr/pgmspace.h>
#include	<stdlib.h>
#include	<string.h>

#include	"BK1.h"

#define		BEEP_VOL_DIFF	0x18	// BEEP̃{[ʏ艺
#define		VOLUME_DEFAULT	0x40	// ftHg{[

// eXgpAgo̓f[^		BeepƂĎg
PROGMEM uchar BeepData[] = { 0x53, 0xEF, 0x6E, 0xF0, 0, 0, 0, 0 };	// 1500Hz
PROGMEM uchar ErrorBeep[] = { 0x53, 0xEF, 0x6E, 0xA4, 0, 0, 0, 0 };	// 500Hz
PROGMEM uchar BeepStop[] = { 0x45, 0x78, 0x69, 0x74, 0, 0, 0, 0 };	// ~߂

uchar	DiskCache[512];	// fBXNLbV
//uchar	DataBuff[256];	// f[^obt@
ulong	DiskCacheAddr;	// LbVĂAhX

uint	Cluster;		// ݍĐ̃NX^
uint	PlayMusic;		// Đ̋Ȕԍ
uint	MusicCount;		// ݂̃J[hɓĂȐ
ulong	MusicSize;		// Đ̋Ȃ̃TCY
long	RemainSec;		// Đ̋Ȃ̎cZN^
char	NoBusyRetry;	// BUSYɂȂȂ̂ŃgCƂtO

uchar	FATtype;		// 1:FAT12  2:FAT16
uchar	SectorsPerCluster;		// 1NX^̃ZN^
ushort	ReservedSectors;	// \ZN^
uchar	FATcount;			// FAT̐ ʏ 2
uint	RootDirEntriesCount;	// [gfBNgGg[
ulong	SectorCount;	// ZN^
uint	FATstart;		// FATJnZN^
ushort	FATsectors;		// FATggZN^
uint	DIRstart;		// [gfBNgJnZN^
ulong	DataStart;		// f[^̈JnZN^

volatile uchar	Volume;			// 
volatile uchar	VolumeReg;		// ݂̎ۂ̉ʐݒl
volatile uchar	FadeInVol;		// tF[hC{[
volatile uint	BattVolt;		// ^C}[荞݂Ŏ擾dd
volatile uchar	SwitchFlag;		// ^C}[荞݂Ŏ擾XCb`̏
volatile uchar	BeepTimer;		// Beep̒

volatile uchar	StopSw;		// START/STOPXCb`̓tO
volatile uchar	RewSw;		// REWXCb`̓tO
volatile uchar	FfSw;		// FFXCb`̓tO
volatile uchar	VolUpSw;	// Vol upXCb`̓tO
volatile uchar	VolDownSw;	// Vol downXCb`̓tO
volatile uchar	Timer;		// ėp^C}
volatile uchar	FlushTimer;	// LED_Ń^C}

volatile uchar	RunningTimeDS;	// ғ(1/100b)
volatile uchar	RunningTimeS;	//     V  (b)

volatile uchar	SleepCounter;		// X[vJE^()
volatile uchar	SleepFlag;		// X[v^C}tO

uchar SleepTime;		// X[v^C}()
ulong VSclock;			// VS1011eNbN
uint BattLowAlerm;		// dxl
uint BattLowShutDown;	// dVbg_El

char	Debug;			// fobOtO


//*********************************
//	^C}[Qrv荞
//	8MHz/1024/78100Hz
//*********************************
ISR(TIMER2_COMPA_vect){
	uchar	old_sw;

	// ėp^C}
	if (Timer){
		--Timer;
	}

	// Beep^C}
	if (BeepTimer){
		--BeepTimer;
	}

	// [obe[oɂ_
	if (++FlushTimer >= 100){
		if (BattVolt < BattLowAlerm){
			DDRD &= ~(1<<LED);	// LED OFF
		}
		FlushTimer = 0;
	} else if (FlushTimer == 50){
		DDRD |= (1<<LED);		// LED ON
	}

	// ғԋL^
	if (++RunningTimeDS >= 100){
		RunningTimeDS = 0;
		if (++RunningTimeS >= 60){
			RunningTimeS = 0;
			// X[v^C}
			if (SleepFlag){
				if (SleepCounter < SleepTime){
					SleepCounter++;
				}
			}
		}
	}

	// XCb``FbN
	old_sw = SwitchFlag;
	SwitchFlag = 0;
	if (!(PIND & (1<<SW_PORT_STOP))){
		if (old_sw & (1<<SW_STOP)){
			if (++StopSw == 0)	StopSw = 255;
		} else {
			StopSw = 1;
		}
		SwitchFlag = (1<<SW_STOP);
	}

	if (!(PIND & (1<<SW_PORT_REW))){
		if (old_sw & (1<<SW_REW)){
			if (++RewSw == 0)	RewSw = 255;
		} else {
			RewSw = 1;
		}
		SwitchFlag |= (1<<SW_REW);
	}

	if (!(PIND & (1<<SW_PORT_VOLDOWN))){
		if (++VolDownSw == 0)	VolDownSw = 255;
		if (VolDownSw >= 20){
			Volume += 8;
			if (Volume >= 0xB8)	Volume = 0xB0;
			VolDownSw = 1;
		}
		SwitchFlag |= (1<<SW_VOLDOWN);
	} else {
		VolDownSw = 0;
	}

	if (!(PIND & (1<<SW_PORT_VOLUP))){
		if (++VolUpSw == 0)	VolUpSw = 255;
		if (VolUpSw >= 20){
			Volume -= 8;
			if (Volume >= 0xF8)	Volume = 0x00;
			VolUpSw = 1;
		}
		SwitchFlag |= (1<<SW_VOLUP);
	} else {
		VolUpSw = 0;
	}

	// tF[hC{[
	if (FadeInVol){
		if (FadeInVol >= 4){
			Volume -= 4;
		} else {
			Volume = FadeInVol;
		}
		if (Volume <= FadeInVol)	FadeInVol = 0;
	}

	// A/DϊJn vXP[ 8MHz/64 = 125kHz
	ADCSRA = (1<<ADEN)|(1<<ADSC)|(1<<ADIE)|(1<<ADPS1)|(1<<ADPS2);
}


//*********************************
//	A/Dϊ̊荞݃[`
//*********************************
ISR(ADC_vect) {

	// A/Dϊʊi[
	// ADCL  ADCH ̏ɃANZXKv
	BattVolt = (uint)ADCL;
	BattVolt |= (((uint)ADCH & 3) << 8);
}


//*********************************
//	sω荞݃[`
//*********************************
ISR(PCINT1_vect) {
	// CPUN
	;
}


//*********************************
//	C[`
//*********************************
int main (void) {
	uchar	ret;
	uchar	start_volume;
	struct DIRECTORY dir;

	cli();
	PORTB = (1<<PB7)|(1<<PB6)|(1<<MMC_CS)|(1<<MMC_MOSI)|(1<<MMC_SCK)|(1<<MP3_CTRL_CS)|(1<<MP3_DATA_CS);
	DDRB = (1<<MMC_SCK)|(1<<MMC_CS)|(1<<MMC_MOSI)|(1<<MP3_CTRL_CS)|(1<<MP3_DATA_CS);

	PORTC = (1<<SCL)|(1<<SDA);
	DDRC = (1<<POWER)|(1<<MP3_RESET);

	PORTD = (1<<SW_PORT_START)|(1<<SW_PORT_REW)|(1<<SW_PORT_VOLUP)|(1<<SW_PORT_VOLDOWN)|(1<<ROM_CS)|(1<<TXD)|(1<<RXD);
	DDRD = (1<<LED);

	if (MCUSR & (1<<WDRF)){
		// EHb`hbOZbg
		shutdown(1);	// Vbg_E
	}
	MCUSR = 0;

	WDR;
	WDTCSR = (1<<WDCE)|(1<<WDE);	// WDCEWDE1ɂă^C}[ύX
	WDTCSR = (1<<WDE)|(1<<WDP2)|(1<<WDP1)|(1<<WDP0);	// EHb`hbO^C}[Zbg Qb

	ADMUX = (1<<REFS1)|(1<<REFS0)|BATT_VOLT;	// d 1.1V, A/D ch
	ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);	// A/DϊHON vXP[ 8MHz/64 = 125kHz

	TCCR2A = (1<<WGM21);					// CTC
	TCCR2B = (1<<CS22)|(1<<CS21)|(1<<CS20);	// vXP[ 1/1024
	OCR2A = 78 - 1;			// ^C}JEgől  8MHz/1024/78100Hz
	TIMSK2 = (1<<OCIE2A);	// r`荞݋

	SMCR = (1<<SE);			// X[v ACh[h

	// TWI, TIMER0, TIMER1, USART d̓Jbg
	PRR = (1<<PRTWI)|(1<<PRTIM0)|(1<<PRTIM1)|(1<<PRUSART0);
	ACSR = (1<<ACD);			// AiORp[^֎~

	PCMSK1 = (1<<PCINT9);	// PCINT9(DREQ)荞݃}XN
	PCICR = (1<<PCIE1);		// sω荞݂P
	
	SwitchFlag = 0;
	NoBusyRetry = 0;
	DiskCacheAddr = -1;
	VolumeReg = 0xFF;
	FlushTimer = 0;
	SleepCounter = 0;
	SleepFlag = 0;

	// ғ
	RunningTimeDS = 0;
	RunningTimeS = 0;

	sei();		// 荞݋

	PORTC |= (1<<POWER);	// POWERێ
	PORTD |= (1<<LED);		// LED_

	// VS1011Zbg
	PORTC |= (1<<MP3_RESET);

	// 肷܂ 0.1b҂
	Timer = 10;
	while(Timer)	SLEEP;

	// VS1011e 
	MP3_init();

	WDR;
	Timer = 20;	//  0.2b

	// 
	Volume = read_eeprom(EEPROM_VOLUME);
	if ((Volume & 7) == 7)	Volume = VOLUME_DEFAULT;
	start_volume = Volume;

	// eݒl
	SleepTime = read_eeprom(EEPROM_SLEEP);
	if (SleepTime == 0xFF)	SleepTime = 30;	// X[v()
	VSclock = read_eeprom_long(EEPROM_VS_CLOCK);
	if (VSclock == 0xFFFFFFFF){
		VSclock = 24576000;		// 24.576MHz
	}
	BattLowAlerm = read_eeprom_word(EEPROM_LOW_BATT);
	if (BattLowAlerm == 0xFFFF){
		BattLowAlerm = 503;	// 3.3V
	}
	BattLowShutDown = read_eeprom_word(EEPROM_SHUTDOWN);
	if (BattLowShutDown == 0xFFFF){
		BattLowShutDown = 473;	// 3.1V
	}
	

	// EEPROMOĐĂȏ擾
	PlayMusic = read_eeprom(EEPROM_MUSIC);
	Cluster = read_eeprom_word(EEPROM_CLUSTER);
	RemainSec = read_eeprom_long(EEPROM_REMAIN);
	MusicSize = read_eeprom_long(EEPROM_SIZE);

	// {[DOWNȂNftHg{[ɂǂ
	if (SwitchFlag & (1<<SW_VOLDOWN)){
		start_volume = Volume = VOLUME_DEFAULT;
	}

	// {[UPȂNX[v
	if (SleepTime && (SwitchFlag & (1<<SW_VOLUP))){
		SleepFlag = 1;
	}

	// MMC/SD SPI
	ret = InitCard();

	WDR;

	// 0.2b҂
	while(Timer)	SLEEP;

	if (ret == 0xFF){	// MMC/SDJ[h
		beep(3, BEEP_LOW);
		shutdown(1);	// Vbg_E
	} else if (SleepFlag){
		beep(2, BEEP_HIGH);	// X[v[h
	} else {
		beep(1, BEEP_HIGH);	// BEEP
	}

	// VFATǂݎ
	if (read_VFAT_info()){
		beep(2, BEEP_LOW);	// VFATُ̈
		shutdown(1);
	}

	// J[h̋ȐmF
	MusicCount = search_MP3(0xFFFF, &dir);

	if (MusicCount == 0){
		// MP3t@C
		beep(1, BEEP_LOW);
		shutdown(1);	// Vbg_E
	}

	if (PlayMusic == 0)	PlayMusic = 1;

	// MMC/SDJ[hꂽǂׂ
	search_MP3(PlayMusic, &dir);
	if (MusicSize != dir.size){
		// tȂ̃TCYقȂĂΌꂽƂ݂Ȃ
		PlayMusic = 1;
		Cluster = 0;
	}

	for(;;){
		char	r;

		if (PlayMusic > MusicCount)	PlayMusic = 1;

		switch_wait();		// XCb`܂ő҂
		if (start_volume){
			// N Vol.UP/DOWNȂNꍇ̉ʕ␳
			Volume = start_volume;
			set_volume(Volume);
			start_volume = 0;
		}
		// Đ
		r = play_music(PlayMusic, Cluster, RemainSec);

		switch_wait();		// XCb`܂ő҂
		if (r < 0){
			beep(-r, BEEP_LOW);		// G[
			shutdown(0);
		} else if (r == 1){		// rSTOPꂽ
			if (StopSw > 30){	// 300msȏ̒ STOP
				shutdown(0);	// d؂
			} else {
				// Zꍇ͎̋
				PlayMusic++;
				Cluster = 0;
			}
		} else if (r == 3){		// REW
			if (RewSw > 100){	// 1bȏ͍̒ŏ̋
				PlayMusic = 1;
			} else if (RewSw > 25){	// 250msȏ̒͑Ő
				if (--PlayMusic == 0){
					PlayMusic = MusicCount;
				}
			}
			Cluster = 0;	// Ȃ̍ŏ
		} else {	// FF or ̋Ȃ̍ĐI
			PlayMusic++;	// ̋
			Cluster = 0;
			MusicSize = 0;
		}

		// X[v^C}
		if (SleepFlag){
			if (SleepCounter >= SleepTime){
				// ̋Ȃ̃t@CTCY EEPROMɏ
				if (PlayMusic > MusicCount)	PlayMusic = 1;
				search_MP3(PlayMusic, &dir);
				MusicSize = dir.size;
				shutdown(0);
			}
		}

		// xdȉɂȂȊԂɌx
		if (BattVolt < BattLowAlerm){
			beep(1, BEEP_LOW);
		}
	}
}


//*********************************************************
//	MP3t@C{
//	F
//		num	̐߂
//		̐ȉłĂfBNgGgSĒ׏I߂
//	߂lF
//		
//		*dir	ŌɌ MP3̃fBNg
//*********************************************************
uint search_MP3(uint num, struct DIRECTORY *dir){
	uint	ent;
	ulong	sec;
	uint	n;

	n = 0;
	sec = (ulong)DIRstart * 512;
	for (ent = 0; ent < RootDirEntriesCount; ent++ ){
		read_32(sec, (uchar *)dir);
		sec += 32;
		if (dir->filename[0] == 0){
			break;	// Ō܂ŒT
		}
		if ((!(dir->att & 0x18))&&	// fBNg{[ȊO
			((dir->cluster != 0)&&	// NX^ԍ
			 (dir->filename[0] != 0xE5)&&						// 폜}[N
			 (strncmp_P((char *)&(dir->ext), PSTR("MP3"), 3) == 0))){
															// gqMP3
			n++;
			if (--num == 0)	break;
		}
	}

	return n;
}


//****************************************
//	MP3t@CĐ
//	fn:		Ȕԍ
//	clst:	tJnNX^B==0 ̏ꍇ͍ŏ
//	remainsec: Đf[^cZN^
//****************************************
char play_music(uint fn, uint clst, long remainsec){
	ulong	sec;
	uint	remain;
	uint	cn;
	uint	i;
	uchar	*p;
	uint	last_cluster;
	uint	cluster;
	struct DIRECTORY dir;

	if (fn != search_MP3(fn, &dir)){
		return -1;	// Ȃ
	}

	MusicSize = dir.size;
	cluster = dir.cluster;

	if (clst){
		// rĐ
		Cluster = clst;
		RemainSec = remainsec;

		// tF[hC
		FadeInVol = Volume;
		Volume = 0xC0;		// ʂقڃ[
		set_volume(Volume);
		
	} else {
		// ŏĐ
		Cluster = dir.cluster;
		RemainSec = MusicSize / 512;
	}
	remain = MusicSize % 512;	// 1ZN^ɖȂ

	if ((Cluster == 0xFFFF)||(Cluster < 2)){
		return -5;	// NX^ُ
	}

	last_cluster = check_cont_cluster(Cluster);

	StopSw = 0;
	RewSw = 0;
	FfSw = 0;

	cn = SectorsPerCluster;
	sec = cluster_to_adrs(Cluster);

	Timer = 100;	// READY^C}[Zbg

	while (RemainSec > 0){

		WDR;
		set_volume(Volume);

		// f[^obt@ɂPZN^̃f[^ǂݍ
		if (read_card(sec))	return -6;

		// VS1011֓]
		PORTB &= ~(1<<MP3_DATA_CS);
		p = DiskCache;
		for (i = 0; i < 512; i++){
			while (!(PINC & (1<<MP3_DREQ))){	// VS1011 BUSY`FbN
				WDR;			// EHb`hbO^C}[Zbg
				Timer = 100;	// READY^C}Zbg
				SLEEP;			// sω荞ݑŋN
			}
			SPI_out(*p++);
		}
		PORTB |= (1<<MP3_DATA_CS);

		if (Timer == 0){	// READY^CAEg
			if (NoBusyRetry > 0){	// gCĂ_Ȃ
				beep(1, BEEP_LOW);	// ቹr[vP
				NoBusyRetry = 0;
				FfSw = 0;
				return 2;		// FFŏI  ̋Ȃ
			} else {
				NoBusyRetry = 1;
				RewSw = 0;
				return 3;		// REWŏI  ̋Ȃ̍ŏ烊gC
			}
		}

		// STOP, FF{^`FbN
		if (StopSw > 2){
			beep(1, BEEP_HIGH);
			NoBusyRetry = 0;
			// ȂpĐꍇɔĎcZN^␮
			RemainSec += (SectorsPerCluster - cn);
			return 1;
		} else if (FfSw > 2){
			beep(1, BEEP_HIGH);
			NoBusyRetry = 0;
			return 2;
		} else if (RewSw > 2){
			beep(1, BEEP_HIGH);
			NoBusyRetry = 0;
			return 3;
		}

		--RemainSec;
		
		if (--cn > 0){
			sec += 512;	// ̃ZN^
		} else {
			// ̃NX^
			if (++Cluster > last_cluster){
				// NX^sÂœǂݒ
				Cluster = next_cluster(--Cluster);
				last_cluster = 0;

				if ((Cluster < 2)||(Cluster == 0xFFFF)){
					// ُNX^oꂽ̂ŋI
					remain = 0;
					break;
				}
			}

			sec = cluster_to_adrs(Cluster);
			cn = SectorsPerCluster;
		}

		check_batt();	// obe[`FbN
	}

	NoBusyRetry = 0;

	// PZN^(512bytes)̕Đ
	if (remain > 0){

		// f[^obt@ɂPZN^̃f[^ǂݍ
		if (read_card(sec))	return -7;

		// VS1011֓]
		PORTB &= ~(1<<MP3_DATA_CS);
		p = DiskCache;
		for (i = 0; i < remain; i++){
			while (!(PINC&(1<<MP3_DREQ))){	// VS1011 BUSY`FbN
				WDR;			// EHb`hbO^C}[Zbg
				SLEEP;			// sω荞ݑŋN
			}
			SPI_out(*p++);
		}
		PORTB |= (1<<MP3_DATA_CS);
	}

	// [𑗂
	PORTB &= ~(1<<MP3_DATA_CS);
	for (i = 0; i < 256; i++){		// obt@TCY
		while (!(PINC&(1<<MP3_DREQ))){	// VS1011 BUSY`FbN
			WDR;			// EHb`hbO^C}[Zbg
		}
		SPI_out(0);
	}
	PORTB |= (1<<MP3_DATA_CS);

	// ĐI҂
	for (i = 0; i < 100 * 2; i++){
		WDR;
		SLEEP;
		SLEEP;
		if (MP3_command_read(SCI_HDAT0) != 0)	continue;
		if (MP3_command_read(SCI_HDAT1) == 0)	break;
	}

	return 0;
}


//*******************************************************
//	obe[d𒲂ׁAႷ΃Vbg_E
//*******************************************************
int check_batt(void){
	uint volt;

	cli();
	volt = BattVolt;
	sei();

	if (volt < BattLowShutDown){
		PORTB |= (1<<MMC_CS);		// SPI CS=H

		write_eeprom_word(32, volt);

		beep(4, BEEP_LOW);
		shutdown(0);	// Vbg_E
	}

	return volt;
}


//*********************************************************
//	Vbg_E
//	flag != 0 ̏ꍇ EEPROM݂s킸ɓd؂
//*********************************************************
void shutdown(char flag){

	WDR;

	// VS1011e AiOhCop[_E
	MP3_command(SCI_STATUS, MP3_command_read(SCI_STATUS)|SS_APDOWN2);
	
	if (!flag){
		write_eeprom(EEPROM_VOLUME, Volume);
		write_eeprom_word(EEPROM_MUSIC, PlayMusic);
		write_eeprom_word(EEPROM_CLUSTER, Cluster);
		write_eeprom_long(EEPROM_REMAIN, RemainSec);
		write_eeprom_long(EEPROM_SIZE, MusicSize);

		write_eeprom_long(EEPROM_VS_CLOCK, VSclock);
		write_eeprom_word(EEPROM_LOW_BATT, BattLowAlerm);
		write_eeprom_word(EEPROM_SHUTDOWN, BattLowShutDown);
		write_eeprom(EEPROM_SLEEP, SleepTime);
	}

	// |bvmCYh߁AVS1011ẽAiOHp[_E܂ő҂
	Timer = 10;
	while(Timer){
		SLEEP;
	}

	switch_wait();			// XCb`܂ő҂

	cli();					// ݋֎~

	for (;;){
		PORTC &= ~(1<<POWER);	// POWERێ
		WDR;
	}
}


//*******************************************************
//	EEPROM 
//*******************************************************
void write_eeprom(uchar adrs, uchar data){

	// eȂ珑ݓsȂ
	if (read_eeprom(adrs) != data){
		while(EECR & (1<<EEPE));
		EEARH = (adrs >> 8);
		EEARL = adrs;
		EEDR = data;
		EECR |= (1<<EEMPE);
		EECR |= (1<<EEPE);
	}
}


//*******************************************************
//	EEPROM (ushort)
//*******************************************************
void write_eeprom_word(uint adrs, ushort data){

	write_eeprom(adrs++, data);
	write_eeprom(adrs, data>>8);
}


//*******************************************************
//	EEPROM (ulong)
//*******************************************************
void write_eeprom_long(uint adrs, ulong data){

	write_eeprom(adrs++, data);
	write_eeprom(adrs++, data>>8);
	write_eeprom(adrs++, data>>16);
	write_eeprom(adrs, data>>24);
}


//*******************************************************
//	EEPROM ǂݍ
//*******************************************************
uchar read_eeprom(uchar adrs){

	while(EECR & (1<<EEPE));
	EEARH = adrs >> 8;
	EEARL = adrs;
	EECR |= (1<<EERE);
	return EEDR;
}


//*******************************************************
//	EEPROM ǂݍ(ushort)
//*******************************************************
ushort read_eeprom_word(uint adrs){
	ushort data;

	data = (ulong)read_eeprom(adrs++);
	data |= (ulong)read_eeprom(adrs) << 8;

	return data;
}


//*******************************************************
//	EEPROM ǂݍ(ulong)
//*******************************************************
ulong read_eeprom_long(uint adrs){
	ulong data;

	data = (ulong)read_eeprom(adrs++);
	data |= (ulong)read_eeprom(adrs++) << 8;
	data |= (ulong)read_eeprom(adrs++) << 16;
	data |= (ulong)read_eeprom(adrs) << 24;

	return data;
}


//*********************************
//	ۂɃWX^삵ĉʐݒ
//*********************************
void set_volume(uchar vol){

	if (vol != VolumeReg){
		MP3_command(SCI_VOL, ((uint)vol << 8)|((uint)vol));	// ʐݒ
		VolumeReg = vol;
	}
}


//****************************************
//	BEEP
//	F	n	
//			err	!= 0 ȂG[(Ⴂ)
//	SLEEPĝŊ荞݋ŌĂяo
//****************************************
void beep(uchar n, char err){
	unsigned char	vol;

	MP3_init();
	
	MP3_command(SCI_MODE, SM_SDINEW|SM_TESTS);	// eXg[h
	MP3_wait();

	beep_wait(1);
	
#if BEEP_VOL_DIFF
	// {[
	vol = Volume + BEEP_VOL_DIFF;
	if (vol >= BEEP_VOL_DIFF){
		MP3_command(SCI_VOL, ((uint)vol << 8)|((uint)vol));	// ʐݒ
	} else {
		vol = 0;	// ʕύXȂ
	}
#endif

	// 30ms
	beep_wait(3);

	for (; n > 0; --n){
		if (err){
			MP3_sin(ErrorBeep);
		} else {
			MP3_sin(BeepData);
		}
		// ԑ҂B̊Ԃ BEEP̉̒ɂȂ
		beep_wait(10);	// 100ms

		MP3_sin(BeepStop);

		// BEEP̉ 30ms
		beep_wait(3);
	}

	// 100ms
	beep_wait(10);

	MP3_command(SCI_MODE, SM_SDINEW);			// SM_TEST=0
	MP3_wait();

#if BEEP_VOL_DIFF
	MP3_command(SCI_VOL, ((uint)Volume << 8)|((uint)Volume));	// ʐݒ
	MP3_wait();
#endif

	beep_wait(3);
}


//****************************************
//	beep()̎ԑ҂
//****************************************
void beep_wait(uchar n){

	BeepTimer = n;
	while(BeepTimer){
		SLEEP;
	}
}


//****************************************
//	VS1011 
//****************************************
void MP3_init(void){
	uint	val;

	// SPI}X^, CPOL=1, CPHA=1, Clock 8MHz/4=2MHz
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA);
	SPI_in();

	MP3_wait();

	MP3_command(SCI_MODE, SM_SDINEW|SM_RESET);			// Soft Reset
	MP3_wait();

	val = (uint)(VSclock / 2000L);	// Clock
	if (val < 10000){	// 20MHzȉȂ
		val |= 0x8000;	// NbN_uݒ
	}
	do {
		MP3_command(SCI_CLOCKF, val);
	} while(MP3_command_read(SCI_CLOCKF) != val);

	MP3_command(SCI_VOL, ((uint)Volume << 8)|((uint)Volume));	// ʐݒ

	for (val = 0; val < 20000; val++){
		NOP;
	}
}


//****************************************
// VS1011n[hEFAZbg
//****************************************
void VS1011_reset(void){

	PORTC &= ~(1<<MP3_RESET);
	SLEEP;
	PORTC |= (1<<MP3_RESET);
	SLEEP;

	MP3_wait();
}


//****************************************
//	VS1011 eXgpgo
//****************************************
void MP3_sin(PGM_VOID_P data){
	uchar	i;
	uchar	c;

	PORTB |= (1<<MMC_CS);
	PORTB |= (1<<MP3_CTRL_CS);
	PORTB &= ~(1<<MP3_DATA_CS);

	for (i=0; i < 8; i++){
		SPI_out(0);
	}
	for (i=0; i < 8; i++){
		c = (uchar)pgm_read_byte(data++);
		SPI_out(c);
	}
	// ]Ƀ[𑗂 Ȃ STOPAςȂɂȂ邱Ƃ
	for (i=0; i < 8; i++){	// ͓KB炵ĂȂ
		SPI_out(0);
	}
	PORTB |= (1<<MP3_DATA_CS);
}


//****************************************
//	VS1011 R}hI҂
//****************************************
void MP3_wait(void){

	InitWait();
	while(!(PINC&(1<<MP3_DREQ)));
}


//****************************************
//	VS1011 R}ho
//****************************************
void MP3_command(uchar addr, uint arg){

	MP3_wait();

	PORTB |= (1<<MMC_CS)|(1<<MP3_DATA_CS);
	PORTB &= ~(1<<MP3_CTRL_CS);
	SPI_out(2);
	SPI_out(addr);
	SPI_out(arg >> 8);
	SPI_out(arg);
	PORTB |= (1<<MP3_CTRL_CS);
}


//****************************************
//	VS1011 R}h
//****************************************
uint MP3_command_read(uchar addr){
	uint	r = 0;

	while(!(PINC&(1<<MP3_DREQ)));

	PORTB |= (1<<MMC_CS)|(1<<MP3_DATA_CS);
	PORTB &= ~(1<<MP3_CTRL_CS);
	SPI_out(3);
	SPI_out(addr);
	r = SPI_in() << 8;
	r |= SPI_in();
	PORTB |= (1<<MP3_CTRL_CS);
	return r;
}


//****************************************
//	̃NbNEGCg
//****************************************
void InitWait(void){
	uchar	i;

	for(i=0; i< 255; i++){
		NOP;
		NOP;
	}
}


//*********************************************************
//	A/DRo[^f[^
// ch :		A/D`l
// ߂l:	A/Dϊl(0`1023)
//*********************************************************
uint ADCin(char ch){
	uint	val;

	ADMUX = (1<<REFS1)|(1<<REFS0)|ch;	// d 1.1V, A/D ch
	ADCSRA = (1<<ADEN)|(1<<ADPS2)|(1<<ADPS1);	// A/DϊHON vXP[ 7.3728MHz/64 = 115kHz

	ADCSRA |= (1<<ADSC);			// ϊJn

	while(!(ADCSRA&(1<<ADIF)));		// ADIF=1 ɂȂ܂Ń[v
	ADCSRA |= (1<<ADIF);			// ADIFNA(1ƃNA)

	val = (uint)ADCL;	
	return (((uint)ADCH)<<8)|val;
}


//*********************************************************
//	XCb`mɕ܂ő҂
//*********************************************************
void switch_wait(void){

	sei();
	for (;;) {
		WDR;
		SLEEP;
		SLEEP;
		if (!(SwitchFlag & ((1<<SW_FF)|(1<<SW_STOP)|(1<<SW_REW)))){
			SLEEP;
			SLEEP;
			if (!(SwitchFlag & ((1<<SW_FF)|(1<<SW_STOP)|(1<<SW_REW)))){
				break;
			}
		}
	}
}


//*********************************************************
//	VFATǂݎ
//*********************************************************
uchar read_VFAT_info(void){
	uchar	buff[32];
	ulong	sec;
	ushort	bpb;
	ushort	n;

	// VFATǂݎBZN^ 512bytesŌߑłĂ
	read_32(446, buff);								// MBRǂݍ
	bpb = *((ushort *)&buff[8]);					// BPB擪ZN^

	read_32((ulong)bpb * 512, buff);				// ǂݍ
	n = *((ushort *)&buff[11]);						// ZN^
	if (n != 512){
		return 2;	// 1ZN^ 512bytesłȂ
	}

	FATcount = buff[16];		// FAT̐ ʏ 2

	SectorsPerCluster = buff[13];		// NX^̃ZN^
	ReservedSectors = *((ushort *)&buff[14]);	// \ZN^
	FATstart = bpb + ReservedSectors;			// FATJnZN^

	RootDirEntriesCount = *((ushort *)&buff[17]);	// [gfBNgGg

	FATsectors = *((ushort *)&buff[22]);		// FAT̃ZN^
	if (FATsectors == 0){
		return 1;	// FAT32炵
	}

	DIRstart = (ushort)FATstart + (ushort)FATcount * FATsectors;	// FAT̐~ZN^
	n = RootDirEntriesCount / 16;	// [gfBNgɕKvȃZN^
//	if (RootDirEntriesCount % 16){
//		n++;	// Ô߁A]肪o؂グBʏ͕svƎv
//	}
	DataStart = (ulong)DIRstart + (ulong)n;		// f[^i[̈

	sec = (ulong)*((ushort *)&buff[19]);		// ZN^
	if (sec == 0){
		read_32((ulong)bpb * 512 + 32, buff);	// ǂݍ
		sec = *((ulong *)&buff[0]);
	}
	SectorCount = sec;
	sec -= FATstart;
	sec /= SectorsPerCluster;
	if (sec >= 0x1000){
		FATtype = FAT16;	// FAT16
	} else {
		FATtype = FAT12;	// FAT12
	}

	// ǂݍ݂Ȃȉ͕̏sv
	
	// f[^̈ZN^
//	sec = SectorCount - ReservedSectors - FATsectors * FATcount - (ulong)RootDirEntriesCount * 32 / 512;

	// NX^
//	ClusterCount = (ushort)(sec / SectorsPerCluster) + 2;

	return 0;
}


//**********************************************
//	t@CI[v
//**********************************************
void open_file(struct DIRECTORY *dir, struct FILE_DATA *fd){

	fd->size = (ushort)dir->size;
	fd->sc = 0;
	fd->cluster = dir->cluster;
	fd->sec = cluster_to_adrs(fd->cluster);
	fd->p = 0;
}


//**********************************************
//	̃ZN^w
//**********************************************
void next_sector(struct FILE_DATA *fd){

	fd->sec += 512;
	fd->p += 512;
	if (++(fd->sc) >= SectorsPerCluster){
		fd->cluster = next_cluster(fd->cluster);
		fd->sec = cluster_to_adrs(fd->cluster);
		fd->sc = 0;
	}
}


//*********************************************************
//	NX^ԍf[^i[AhX擾
//*********************************************************
ulong cluster_to_adrs(uint cluster){

	return (((ulong)cluster - 2) * (ulong)SectorsPerCluster + DataStart) * 512;
}


//*********************************************************
//	̃NX^߂
//*********************************************************
uint next_cluster(uint c){
	ulong	addr;
	uint	data;
	ulong	fatadr;

	if (FATtype == FAT12){
		// FAT12
		addr = (ulong)FATstart * 512 + (ulong)c + (c >> 1);
		if ((addr & 511) == 511){
			// ZN^܂
			data = read_word(addr) & 0x00FF;
			data |= ((read_word(addr+1) & 0x00FF) << 8);
		} else {
			fatadr = addr & 0xFFFFFE00;
			data = read_word(addr);
		}
		if (c & 1){
			c = data >> 4;
		} else {
			c = data & 0x0fff;
		}
		if (c >= 0x0ff8)	c = 0xFFFF;
	} else {
		// FAT16
		addr = (ulong)FATstart * 512 + (ulong)c * 2;
		fatadr = addr & 0xFFFFFE00;
		c = read_word(addr);
		if (c >= 0xFFF8)	c = 0xFFFF;
	}

	return c;
}


//****************************************
//	ANX^o
//	߂lFAŌ̃NX^
//****************************************
uint check_cont_cluster(uint c){
	uint	next;

	for(;;) {
		next = next_cluster(c);
		if (++c != next){
			--c;
			break;
		}
	}

	return c;
}


//****************************************
//	MMC/SDJ[h 2byteǂ
//	ZN^ẼANZX͂łȂ̂
//	ʍHōl邱
//****************************************
uint read_word(ulong addr){
	uint	w;
	uint	b;

	b = addr & 511;
	addr &= 0xFFFFFE00;

	read_card(addr);

	w = (uint)DiskCache[b++];
	w |= ((uint)DiskCache[b] << 8);

	return w;
}


//****************************************
//	MMC/SDJ[h 32byteǂ
//****************************************
void read_32(ulong addr, uchar *buff){
	uint	b;
	int		i;

	b = addr & 511;
	addr &= 0xFFFFFE00;

	read_card(addr);

	for (i = 0; i < 32; i++){
		*buff++ = DiskCache[b++];
	}
}


//*******************************************************
// SD/MMCJ[hPZN^ DiskCacheɓǂݍ
//*******************************************************
int read_card(ulong addr){
	uint	i;
	uchar	r;
	uchar	*buff;

	// fBXNLbVAhXr
	if (addr == DiskCacheAddr)	return 0;
	DiskCacheAddr = addr;
	
//	SPSR |= ~(1<<SPI2X);	// SPINbN 4MHz

	MMC_CS_ON;
	r = SPI_command(17, addr);
	if (r == 0){
		for (i = 0; i < 10000; i++){	// ̂҂ꍇ
			r = SPI_in();
			if (r == 0xFE){
				break;		// ]Jn}[N
			}
		}
	}

	if (r != 0xFE){
		r = 1;
		goto QUIT;		// ERROR
	} else {
		r = 0;
	}

	buff = DiskCache;
	for (i = 0; i < 512; i++){
		*buff++ = SPI_in();
	}

	SPI_in();	// CRC
	SPI_in();	// CRC

  QUIT:
	MMC_CS_OFF;
	SPI_in();
//	SPSR &= ~(1<<SPI2X);	// SPINbN 2MHzɂǂ

	return r;
}


//*********************************************************
//	MMC/SDJ[h̏( SPȈ)
//*********************************************************
uchar InitCard(void){
	uchar	c;

	// SPI}X^, CPOL=1, CPHA=1, Clock 8MHz/64=125kHz
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<CPOL)|(1<<CPHA)|(1<<SPR1);

	MMC_CS_OFF;	// CS=H

	// MMC/SD SPI[hڍsÕNbNM
	for (c = 0; c < 20; c++){
		SPI_in();
	}

	// SPI[hڍsR}h
	WDR;
	MMC_CS_ON;	// CS=L
	c = SPI_command(0, 0);
	while ((c != 1)&&(c != 0xFF)){
		c = SPI_command(0, 0);
		SLEEP;
	}
	while (c == 1){
		c = SPI_command(1, 0);
		SLEEP;
	}
	MMC_CS_OFF;	// CS=H
	SPI_in();

	// SPI Clock 8MHz/4=2MHz
	SPCR &= ~(1<<SPR1);
	SPSR |= (1<<SPI2X);	// SPINbN 4MHz

	return c;
}


//****************************************
//	MMC/SD SPIR}ho
//****************************************
uchar SPI_command(uchar com, ulong arg){
	uint	i;
	uchar	r;

	// BUSY`FbN
	for (i = 0; i < 30000; i++){
		r = SPI_in();
		if (r == 0xFF)	break;
	}
	if (r != 0xFF)	return 1;

	SPI_out(com|0x40);
	SPI_out(arg >> 24);
	SPI_out(arg >> 16);
	SPI_out(arg >> 8);
	SPI_out(arg);
	SPI_out(0x95);	// R}hCRC

	// R1҂
	for (i = 0; i < 2000; i++){
		r = SPI_in();
		if (r != 0xFF)	break;
	}

	return r;
}


//****************************************
//	SPIf[^o
//****************************************
void SPI_out(uchar data){

	SPDR = data;
	while(!(SPSR & (1<<SPIF)));
}


//****************************************
//	SPIf[^
//****************************************
uchar SPI_in(void){

	SPDR = 0xFF;
	while(!(SPSR & (1<<SPIF)));
	return SPDR;
}
